////////////////////////////////////////////////////////////////////
// XUG Listbox Programm
// XUG Zrich 2007
/////////////////////////////////////////////////////////////////////

#include "Gra.ch"
#include "Xbp.ch"
#include "Common.ch"
#include "Appevent.ch"
#include "Font.ch"

******************************************************************************
* Prozedure fr Aufruf der zugehrigen Klasse
******************************************************************************
PROCEDURE Listbox_Ausgeben
LOCAL oListBox:=NIL

*   oListbox:=Listbox():new(AppDeskTop())  // -> innerhalb Bildschirm
   oListbox:=Listbox():new(SetAppWindow())  // -> innerhalb Hauptfenster

   oListbox:create()
   ScreenCenter(oListbox)

   // Parameter-bergabe
   oListbox:Run()

   * Formular anzeigen
   oListbox:show()

RETURN




******************************************************************************
* Von der Darstellungsklasse abgeleitete Klasse zur Implementierung der
* Programmlogik. Die Instanzvariablen der einzelnen Objekte sind in der
* Klasse _Listbox deklariert.
******************************************************************************
CLASS Listbox FROM _Listbox
   EXPORTED:
      VAR aArray
      VAR aDbf


      METHOD init
      METHOD create
      METHOD Run
      METHOD closWindow
      METHOD selItem

ENDCLASS

******************************************************************************
* Formular initialisieren
******************************************************************************
METHOD Listbox:init( oParent, oOwner, aPos, aSize, aPP, lVisible )

   * Methode der Superklasse rufen
   ::_Listbox:init( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::aArray   :={}
   ::aDbf     := {}

RETURN self


******************************************************************************
* Systemresourcen anfordern
******************************************************************************
METHOD Listbox:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
local aPPP:=  { { XBP_PP_BGCLR, GRA_CLR_GREEN }, { XBP_PP_FGCLR, GRA_CLR_DARKPINK } }
   * Methode der Superklasse rufen
   ::_Listbox:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::close:= {|mp1,mp2,obj|::closWindow()}

   // Tabulator Stops fr die Listbox setzen in Dot's
   ::oList:setTabStops({20,50})

   // Methoden definieren fr die einzelnen Aktionen
   ::oList:itemSelected := {| uNIL1, uNIL2, obj | ::selItem() }
   ::oList:itemMarked   := {| uNIL1, uNIL2, obj | NIL }

RETURN self

METHOD Listbox:Run()
LOCAL nFeldName:=0, nFeldVorname:=0

   dbuseArea(.T.,,DatenPfad()+"\Customer","CUSTOMER")
   aaDD(::aDbf,alias())
   *
   nFeldName      := customer->(fieldpos("LASTNAME"))
   nFeldVorName   := customer->(fieldpos("FIRSTNAME"))

/*
   // ohne Tabstops
   Customer->(dbeval({||aadd(::aArray, ;
      {alltrim(customer->(fieldget(nFeldName)))+" "+ ;
      alltrim(customer->(fieldget(nFeldVorName))), ;
      recno()})}))
*/
   // mit Tabstops
   Customer->(dbeval({||aadd(::aArray, ;
      {alltrim(customer->(fieldget(nFeldName)))+chr(9)+ ;
      alltrim(customer->(fieldget(nFeldVorName))), ;
      recno()} )}))

   asort(::aArray,,,{|x,y|x[1]<y[1]})
   *
   aeval(::aArray,{|x|::oList:addItem(x[1])})
   *
RETURN self

METHOD ListBox:ClosWindow()
// Datenbanken schliessen
aEval( ::aDbf, {|x,i| dbCloseArea(x)  } )
// Listbox Fenster freigeben
IF self:Status() = XBP_STAT_CREATE
    self:destroy()
ENDI
RETURN self


METHOD ListBox:selItem()
LOCAL aPos := ::oList:getData()  // enthlt ein Array mit allen Markierten Positionen
LOCAL nItemPos,nTabPos,cItem,cVorname,cName

* Je nach Wunsch kann die entsprechende Variante aktiviert bzw. deaktiviert werden
*   (/* */) lschen, neu setzen

   IF aPos != NIL
/*
      //  1. Variante

      //  Auswertung der Listbox wenn mit Tabstops gearbeitet wird
      nItemPos := aPos[1]                       // 1. Markiertes Item in der Listbox
      cItem    := ::oList:getItem(nItemPos)     // ganze Zeile der Listbox
      nTabPos  := at(chr(9),cItem)              // chr(9) suchen innerhalb der Zeile
      IF nTabPos > 0
         cName    := subs(cItem,1,nTabPos-1)            // Auslesen bis hin zum 1. Tab
         cVorName := alltrim(subs(cItem,nTabPos+1,30))  // Rest der Zeile lesen
         *

         msgbox("Name     "+cName+chr(13)+;
                "Vorname  "+cVorname)

      ENDI
*/
      //  2. Variante    Daten aus ::aArray auslesen

      //  Auswertung der Listbox wenn mit Tabstops gearbeitet wird
      nItemPos := aPos[1]                  // 1. Markiertes Item in der Listbox
      *
      cItem    := ::aArray[nItemPos,1]     // Name aus Array lesen
      nTabPos  := at(chr(9),cItem)         // chr(9) suchen innerhalt von cItem
      IF nTabPos > 0
         cName    := subs(cItem,1,nTabPos-1)           // Substring aus Array fr Name
         cVorName := alltrim(subs(cItem,nTabPos+1,30)) // Substring aus Array fr VorName
         *

         msgbox("Name     "+cName+chr(13)+;
                "Vorname  "+cVorname)

      ENDI

/*
      //  3. Variante    Daten aus Datenbank auslesen
      //  Hier wird nur die Recno() aus dem Array geholt
      //  Auswertung der Listbox wenn mit Tabstops gearbeitet wird

      nItemPos := aPos[1]                         // 1. Markiertes Item in der Listbox
      *
      cDbf := ::aDbf[1]                           // customer db definieren
      &cDbf->(dbGoTo(::aArray[nItemPos,2]))       // Datenbank positionieren
      *
      cName    := &cDbf->lastname                 // db auslesen
      cVorName := &cDbf->firstname
      *

      msgbox("Name     "+cName+chr(13)+;
             "Vorname  "+cVorname)

*/

   ENDI
RETURN self

//EOF
/////